<template>
	<aside>
		<section v-if="loggedIn" class="status">
			<h3>Your Vault account</h3>
			<p>Securely logged in</p>
			<p v-if="minutesLeft < 90 && minutesLeft >= 1">Your session expires in {{ minutesLeft }} minutes</p>
			<p v-else-if="minutesLeft >= 1">Your session expires in {{ Math.round((minutesLeft / 60) * 10) / 10 }} hours</p>
			<!--<p>WebAuthn: FIDO2</p>-->
			<button type="button" @click="logout" ref="logout" class="button ghost">log out</button>
		</section>

		<nav v-if="loggedIn">
			<h3>Navigation</h3>
			<ul class="gap_no ma-t_xs">
				<li><router-link :to="{name: 'vault'}" class="block-link bo-t_px">Overview</router-link></li>
				<li><router-link :to="{name: 'settings'}" class="block-link bo-t_px">Settings</router-link></li>
			</ul>
		</nav>

		<nav>
			<h3>External links</h3>
			<ul class="gap_no ma-t_xs">
				<li v-if="links.jslicense"><a :href="links.jslicense" rel="jslicense" target="_blank" class="block-link bo-t_px">JavaScript license information</a></li>
				<li v-if="links.source"><a :href="links.source" rel="noopener" target="_blank" class="block-link bo-t_px">Source code</a></li>
				<li v-if="links.CKP"><a :href="links.CKP" rel="noopener" target="_blank" class="block-link bo-t_px">Cookie Policy</a></li>
				<li v-if="links.PRP"><a :href="links.PRP" rel="noopener" target="_blank" class="block-link bo-t_px">Privacy Policy</a></li>
				<li v-if="links.TOS"><a :href="links.TOS" rel="noopener" target="_blank" class="block-link bo-t_px">Terms of Service</a></li>
			</ul>
		</nav>

		<section>
			<h3>Display options</h3>
			<div class="gap-no scheme">
				<label :class="{box: 1, active: scheme === ExplicitScheme.Light}">
					<input @change="setScheme" class="radio" type="radio" name="color" :value="ExplicitScheme.Light" :checked="scheme === ExplicitScheme.Light">
					Light mode: normal colors
				</label>
				<label :class="{box: 1, active: scheme === ExplicitScheme.Dark}">
					<input @change="setScheme" class="radio" type="radio" name="color" :value="ExplicitScheme.Dark" :checked="scheme === ExplicitScheme.Dark">
					Dark mode: inverted colors
				</label>
				<label :class="{box: 1, active: scheme === ExplicitScheme.OS}">
					<input @change="setScheme" class="radio" type="radio" name="color" :value="ExplicitScheme.OS" :checked="scheme === ExplicitScheme.OS">
					Auto: detect OS settings
				</label>
			</div>
		</section>
	</aside>
</template>

<style scoped>
/* TODO: flex the aside */
.status {
	margin: 0;
	padding: 0;

	& p {
		margin: 0 0 .4em 0;

		&:nth-of-type(1)::before {
			content: "";
			width: 18px;
			height: 18px;
			display: inline-block;
			background-image: url(../assets/icons/user-circle.svg);
			margin-right: 0.3ex;
			margin-bottom: -4px;
		}

		&:nth-of-type(2)::before {
			content: "";
			width: 18px;
			height: 18px;
			display: inline-block;
			background-image: url(../assets/icons/clock.svg);
			margin-right: 0.3ex;
			margin-bottom: -4px;
		}

		&:nth-of-type(3)::before {
			content: "";
			width: 18px;
			height: 18px;
			display: inline-block;
			background-image: url(../assets/icons/shield-check.svg);
			margin-right: 0.3ex;
			margin-bottom: -4px;
		}
	}

	& button {
		margin-top: .6em;
		width: 100%;
	}
}

.scheme {
	& input {
		margin-right: .6ex;
	}
}

.status, nav:not(:last-child), section:not(:last-child) {
	margin-bottom: 3em;
}
</style>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator"
import { ColorScheme } from "../types"

enum ExplicitScheme {
	Light,
	Dark,
	OS, // use os settings
}

@Component({
	computed: {
		loggedIn () {
			return this.$store.getters.isLoggedIn &&
				!this.$store.getters.isExpired() &&
				this.$store.getters.checkedSession
		},
		scheme () {
			return this.$store.state.displayOptions.colorScheme === ColorScheme.Dark ? ExplicitScheme.Dark :
				this.$store.state.displayOptions.colorScheme === ColorScheme.Light ? ExplicitScheme.Light :
					ExplicitScheme.OS
		},
	},
	data () {
		return { ExplicitScheme }
	},
})
export default class Aside extends Vue {
	minutesLeft = Math.ceil(this.$store.getters.timeLeft() / 1000 / 60)
	minutesTimer?: number

	links = {
		PRP: process.env.VUE_APP_PRP,
		CKP: process.env.VUE_APP_CKP,
		TOS: process.env.VUE_APP_TOS,
		jslicense: process.env.VUE_APP_JSLICENSE,
		source: process.env.VUE_APP_SOURCE,
	}

	updateMinutes () {
		this.minutesLeft = Math.ceil(this.$store.getters.timeLeft() / 1000 / 60)
	}

	beforeUpdate () {
		// initial timer update
		if (!this.minutesTimer || this.minutesLeft < 1) {
			this.updateMinutes()
		}
	}

	mounted () {
		this.updateMinutes()
		if (!this.minutesTimer) {
			this.minutesTimer = self.setInterval(this.updateMinutes, 6e4)
		}
	}

	async logout () {
		// explicit session invalidate
		const button = this.$refs.logout as HTMLButtonElement
		const req = new Request(`${process.env.VUE_APP_API}/vault/session`, {
			method: "DELETE",
			mode: "cors",
			cache: "no-cache",
			redirect: "follow",
			referrer: "no-referrer",
			headers: {
				"Accept": "application/json",
				"X-VAULT-SESSION": this.$store.state.session.sessionKey,
				"X-VAULT-TOKEN": this.$store.state.session.secretKey,
			},
		})

		button.disabled = true
		await fetch(req)

		this.$store.commit("session", {})
		this.$router.push({name: "login", params: {logout: "vault"}})
	}

	// TODO: break display options into their own component

	setScheme (e: Event) {
		const newScheme = +(e.target as HTMLInputElement).value

		if (newScheme === ExplicitScheme.Light) {
			return this.$store.commit("setColorScheme", ColorScheme.Light)
		} else if (newScheme === ExplicitScheme.Dark) {
			return this.$store.commit("setColorScheme", ColorScheme.Dark)
		} else {
			const prefersDarkMode = self.matchMedia("(prefers-color-scheme: dark)").matches

			if (prefersDarkMode) {
				return this.$store.commit("setColorScheme", ColorScheme.OSDark)
			} else {
				return this.$store.commit("setColorScheme", ColorScheme.OSLight)
			}
		}
	}
}
</script>
